#define MAXPOS 32

class PosInfo {
   public:
      Int unum ;
      char* name ;
      Pos spos ;
      Pos hpos ;
      Pos range ;
      Pos shift ;
      char* passto[MAXPOS] ;
      Int passtoN ;
     
      inline PosInfo(Int un, char* nm, Pos sp, Pos hp, Pos r, Pos sh) {
	 unum = un ; name = nm ; spos = (Pos)sp ; hpos = (Pos)hp ; 
	 range = (Pos)r ; shift = (Pos)sh ; passtoN = 0 ;
      } ;
      inline PosInfo(Int un, char* nm, Pos sp, Pos hp, Pos r, Pos sh,
		     char* dest0) {
			unum = un ; name = nm ; spos = (Pos)sp ; hpos = (Pos)hp ; 
			range = (Pos)r ; shift = (Pos)sh ; passtoN = 1 ;
			passto[0] = dest0 ;
      } ;
      inline PosInfo(Int un, char* nm, Pos sp, Pos hp, Pos r, Pos sh,
		     char* dest0, char* dest1) {
			unum = un ; name = nm ; spos = (Pos)sp ; hpos = (Pos)hp ; 
			range = (Pos)r ; shift = (Pos)sh ; passtoN = 2 ;
			passto[0] = dest0 ; passto[1] = dest1 ;
      } ;
      inline PosInfo(Int un, char* nm, Pos sp, Pos hp, Pos r, Pos sh,
		     char* dest0, char* dest1, char* dest2) {
			unum = un ; name = nm ; spos = (Pos)sp ; hpos = (Pos)hp ; 
			range = (Pos)r ; shift = (Pos)sh ; passtoN = 3 ;
			passto[0] = dest0 ; passto[1] = dest1 ; passto[2] = dest2 ;
      } ;
      inline PosInfo(Int un, char* nm, Pos sp, Pos hp, Pos r, Pos sh,
		     char* dest0, char* dest1, char* dest2,
		     char* dest3){
			unum = un ; name = nm ; spos = (Pos)sp ; hpos = (Pos)hp ; 
			range = (Pos)r ; shift = (Pos)sh ; passtoN = 4 ;
			passto[0] = dest0 ; passto[1] = dest1 ; passto[2] = dest2 ;
			passto[3] = dest3 ;
      } ;
      inline PosInfo(Int un, char* nm, Pos sp, Pos hp, Pos r, Pos sh,
		     char* dest0, char* dest1, char* dest2,
		     char* dest3, char* dest4){
			unum = un ; name = nm ; spos = (Pos)sp ; hpos = (Pos)hp ; 
			range = (Pos)r ; shift = (Pos)sh ; passtoN = 5 ;
			passto[0] = dest0 ; passto[1] = dest1 ; passto[2] = dest2 ;
			passto[3] = dest3 ; passto[4] = dest4 ;
      } ;
      inline PosInfo(Int un, char* nm, Pos sp, Pos hp, Pos r, Pos sh,
		     char* dest0, char* dest1, char* dest2,
		     char* dest3, char* dest4, char* dest5){
			unum = un ; name = nm ; spos = (Pos)sp ; hpos = (Pos)hp ; 
			range = (Pos)r ; shift = (Pos)sh ; passtoN = 6 ;
			passto[0] = dest0 ; passto[1] = dest1 ; passto[2] = dest2 ;
			passto[3] = dest3 ; passto[4] = dest4 ; passto[5] = dest5 ;
      } ;
} ;

PosInfo PosInfoTable0[] = {
   PosInfo(99,"byunum",		xyP(0,0),xyP(0,0),xyP(60,35),xyP(0,0)),
   PosInfo(98,"random",		xyP(0,0),xyP(0,0),xyP(60,35),xyP(0,0)),
   PosInfo( 1,"goalie",		xyP(-51,  0),xyP(-51,  0),xyP(10,10),xyP(10,5),
	    "l_w_back","r_w_back","l_clear","r_clear"),
   PosInfo( 2,"sweeper",		xyP(-45,  0),xyP(-45,  0),xyP(15,20),xyP(10,5),
	    "l_w_back","r_w_back","l_clear","r_clear"),
   PosInfo( 3,"l_c_back",	xyP(-40,-15),xyP(-40,-15),xyP(20,25),xyP(10,5),
	    "l_w_back","l_o_half","l_clear"),
   PosInfo( 4,"r_c_back",	xyP(-40, 15),xyP(-40, 15),xyP(20,25),xyP(10,5),
	    "r_w_back","r_o_half","r_clear"),
   PosInfo( 5,"l_w_back",	xyP(-25,-25),xyP( -5,-25),xyP(30,10),xyP(10,5),
	    "l_o_half","l_c_forward","r_c_forward"),
   PosInfo( 6,"r_w_back",	xyP(-25, 25),xyP( -5, 25),xyP(30,10),xyP(10,5),
	    "r_o_half","r_c_forward","l_c_forward"),
   PosInfo( 7,"bolanch",		xyP(-30,  0),xyP(-15,  0),xyP(35,20),xyP(10,5),
	    "l_o_half","r_o_half","l_c_forward","r_c_forward"),
   PosInfo( 8,"l_o_half",	xyP(-15,-15),xyP( 20,-20),xyP(35,20),xyP(10,5),
	    "l_c_forward", "goal", "r_c_forward"),
   PosInfo( 9,"r_o_half",	xyP(-15, 15),xyP( 20, 20),xyP(35,20),xyP(10,5),
	    "r_c_forward", "goal", "l_c_forward"),
   PosInfo(10,"l_c_forward",	xyP(-10, -5),xyP( 40, -5),xyP(15,20),xyP(10,5),
	   "goal", "r_c_forward"),
   PosInfo(11,"r_c_forward",	xyP(-10,  5),xyP( 40,  5),xyP(15,20),xyP(10,5),
	   "goal", "r_c_forward"),
   PosInfo( 0,"goal",		xyP( 54,  0),xyP( 54,  0),xyP(0,0),xyP(0,0)),
   PosInfo( 0,"l_clear",		xyP(-30,-35),xyP(-30,-35),xyP(0,0),xyP(0,0)),
   PosInfo( 0,"r_clear",		xyP(-30, 35),xyP(-30, 35),xyP(0,0),xyP(0,0)),
   PosInfo(-1,NULLPTR,		xyP(0,0),    xyP(0,0),    xyP(0,0),xyP(0,0))
} ;
PosInfo PosInfoTable1[] = {
   PosInfo(99,"byunum",		xyP(0,0),xyP(0,0),xyP(60,35),xyP(0,0)),
   PosInfo(98,"random",		xyP(0,0),xyP(0,0),xyP(60,35),xyP(0,0)),
   PosInfo( 1,"goalie",		xyP(-51,  0),xyP(-51,  0),xyP(15,15),xyP(0,0),
	    "l_w_back","r_w_back","l_clear","r_clear"),
   PosInfo( 2,"sweeper",		xyP(-35,  0),xyP(-25,  0),xyP(25,20),xyP(0,0),
	    "l_w_back","r_w_back","d_half","l_clear","r_clear"),
   PosInfo( 3,"l_f_back",	xyP(-40, -8),xyP(-40, -8),xyP(20,30),xyP(0,0),
	    "l_w_back","l_o_half","l_clear"),
   PosInfo( 4,"r_f_back",	xyP(-40,  8),xyP(-40,  8),xyP(20,30),xyP(0,0),
	    "r_w_back","r_o_half","r_clear"),
   PosInfo( 5,"l_w_back",	xyP(-25,-20),xyP( -5,-20),xyP(30,15),xyP(0,0),
	    "l_o_half","l_c_forward","r_c_forward"),
   PosInfo( 6,"r_w_back",	xyP(-25, 20),xyP( -5, 20),xyP(30,15),xyP(0,0),
	    "r_o_half","r_c_forward","l_c_forward"),
   PosInfo( 7,"d_half",		xyP(-10,  0),xyP(  5,  0),xyP(25,20),xyP(0,0),
	    "l_o_half","r_o_half","l_c_forward","r_c_forward"),
   PosInfo( 8,"l_o_half",	xyP(-10,-15),xyP( 20,-15),xyP(35,20),xyP(0,0),
	    "l_c_forward", "goal_l", "r_c_forward"),
   PosInfo( 9,"r_o_half",	xyP(-10, 15),xyP( 20, 15),xyP(35,20),xyP(0,0),
	    "r_c_forward", "goal_r", "l_c_forward"),
   PosInfo(10,"l_c_forward",	xyP( -1, -1),xyP( 40, -5),xyP(15,20),xyP(0,0),
	   "goal_l","goal","goal_r", "r_c_forward"),
   PosInfo(11,"r_c_forward",	xyP( -1,  1),xyP( 40,  5),xyP(15,20),xyP(0,0),
	   "goal_l","goal","goal_r", "r_c_forward"),
   PosInfo( 0,"goal",		xyP( 53,  0),xyP( 53,  0),xyP(0,0),xyP(0,0)),
   PosInfo( 0,"goal_l",		xyP( 53, -3),xyP( 53, -3),xyP(0,0),xyP(0,0)),
   PosInfo( 0,"goal_r",		xyP( 53,  3),xyP( 53,  3),xyP(0,0),xyP(0,0)),
   PosInfo(97,"l_clear",		xyP(-30,-35),xyP(-30,-35),xyP(0,0),xyP(0,0)),
   PosInfo(97,"r_clear",		xyP(-30, 35),xyP(-30, 35),xyP(0,0),xyP(0,0)),
   PosInfo(-1,NULLPTR,		xyP(0,0),    xyP(0,0),    xyP(0,0),xyP(0,0))
} ;

PosInfo PosInfoTable[] = {
   PosInfo(99,"byunum",		xyP(0,0),xyP(0,0),xyP(60,35),xyP(0,0)),
   PosInfo(98,"random",		xyP(0,0),xyP(0,0),xyP(60,35),xyP(0,0)),
   PosInfo( 1,"goalie",		xyP(-51,  0),xyP(-50,  0),xyP(15,15),xyP(5,5),
	    "l_w_back","r_w_back","l_clear","r_clear"),
   PosInfo( 2,"sweeper",		xyP(-35,  0),xyP(-20,  0),xyP(25,20),xyP(20,5),
	    "l_w_back","r_w_back","d_half","l_clear","r_clear"),
   PosInfo( 3,"l_f_back",	xyP(-40, -8),xyP(-30, -8),xyP(20,30),xyP(20,5),
	    "l_w_back","l_o_half","l_clear"),
   PosInfo( 4,"r_f_back",	xyP(-40,  8),xyP(-30,  8),xyP(20,30),xyP(20,5),
	    "r_w_back","r_o_half","r_clear"),
   PosInfo( 5,"l_w_back",	xyP(-25,-20),xyP( -0,-20),xyP(25,10),xyP(10,10),
	    "l_o_half","l_c_forward","r_c_forward"),
   PosInfo( 6,"r_w_back",	xyP(-25, 20),xyP( -0, 20),xyP(25,10),xyP(10,10),
	    "r_o_half","r_c_forward","l_c_forward"),
   PosInfo( 7,"d_half",		xyP(-10,  0),xyP(  5,  0),xyP(25,20),xyP(10,5),
	    "l_o_half","r_o_half","l_c_forward","r_c_forward"),
   PosInfo( 8,"l_o_half",	xyP(-10,-15),xyP( 15,-15),xyP(35,20),xyP(10,5),
	    "l_c_forward", "goal_l", "r_c_forward"),
   PosInfo( 9,"r_o_half",	xyP(-10, 15),xyP( 15, 15),xyP(35,20),xyP(10,5),
	    "r_c_forward", "goal_r", "l_c_forward"),
   PosInfo(10,"l_c_forward",	xyP( -1, -1),xyP( 30, -5),xyP(10,20),xyP(20,5),
	   "goal_l","goal","goal_r", "r_c_forward"),
   PosInfo(11,"r_c_forward",	xyP( -1,  1),xyP( 30,  5),xyP(10,20),xyP(20,5),
	   "goal_l","goal","goal_r", "r_c_forward"),
   PosInfo( 0,"goal",		xyP( 53,  0),xyP( 53,  0),xyP(0,0),xyP(0,0)),
   PosInfo( 0,"goal_l",		xyP( 53, -3),xyP( 53, -3),xyP(0,0),xyP(0,0)),
   PosInfo( 0,"goal_r",		xyP( 53,  3),xyP( 53,  3),xyP(0,0),xyP(0,0)),
   PosInfo(97,"l_clear",		xyP(-30,-35),xyP(-30,-35),xyP(0,0),xyP(0,0)),
   PosInfo(97,"r_clear",		xyP(-30, 35),xyP(-30, 35),xyP(0,0),xyP(0,0)),
   PosInfo(-1,NULLPTR,		xyP(0,0),    xyP(0,0),    xyP(0,0),xyP(0,0))
} ;

     

inline PosInfo* FindPosition(char* name) {
   for(PosInfo* pi = PosInfoTable ; pi->unum >= 0 ; pi++) {
      if(!strcmp(name,pi->name)) return pi ;
   }
   return NULLPTR ;
} ;
inline PosInfo* FindPosition(Int unum) {
   for(PosInfo* pi = PosInfoTable ; pi->unum >= 0 ; pi++) {
      if(unum == pi->unum) return pi ;
   }
   return NULLPTR ;
} ;


